Summary: The GNU libc libraries.
Name: glibc
Version: 2.1.2
%define DATE 991019
Release: 17
Copyright: LGPL
Group: System Environment/Libraries
Source0: glibc-2.1-%{DATE}.tar.gz
Source1: http://www.ozemail.com.au/~geoffk/glibc-crypt/glibc-crypt-2.1.tar.gz
Source2: glibc-compat-2.1.2.tar.gz
Source3: glibc-2.1-nsswitch.conf
Patch0: glibc-2.1-rhpaths.patch
Patch1: glibc-2.1-noversion.patch
Patch2: glibc-2.1-cppfix.patch
Patch3: glibc-2.1.1-nscdhup.patch
Patch4: glibc-2.1-xdr_ypall.patch
Patch5: glibc-2.1-thrlock.patch
Patch6: glibc-2.1-sparcll.patch
Patch7: glibc-2.1-version.patch
Patch8: glibc-2.1-sparcldso.patch
Patch10: glibc-2.1-string-pedantic.patch
Patch11: glibc-2.1.2-sparc-sa.patch
Patch12: glibc-2.1-cs.po.patch
Patch13: glibc-sparc-bcopy.patch
Patch14: glibc-2.1.2-malloc.patch
Buildroot: /var/tmp/glibc-%{PACKAGE_VERSION}-root
Obsoletes: zoneinfo, libc-static, libc-devel, libc-profile, libc-headers,
Obsoletes:  linuxthreads, gencat, locale
Autoreq: false
%ifarch alpha
Provides: ld.so.2
%else
%endif
%ifarch sparc
Obsoletes: libc
%endif

%description
The glibc package contains standard libraries which are used by
multiple programs on the system. In order to save disk space and
memory, as well as to make upgrading easier, common system code is
kept in one place and shared between programs. This particular package
contains the most important sets of shared libraries: the standard C
library and the standard math library. Without these two libraries, a
Linux system will not function.  The glibc package also contains
national language (locale) support and timezone databases.

%package devel
Summary: Header and object files for development using standard C libraries.
Group: Development/Libraries
Conflicts: texinfo < 3.11
Prereq: /sbin/install-info
Obsoletes: libc-debug, libc-headers, libc-devel, linuxthreads-devel
Obsoletes: glibc-debug
Prereq: kernel-headers
Requires: kernel-headers >= 2.2.1
Autoreq: true

%description devel
The glibc-devel package contains the header and object files necessary
for developing programs which use the standard C libraries (which are
used by nearly all programs).  If you are developing programs which
will use the standard C libraries, your system needs to have these
standard header and object files available in order to create the
executables.

Install glibc-devel if you are going to develop programs which will
use the standard C libraries.

%package profile
Summary: The GNU libc libraries, including support for gprof profiling.
Group: Development/Libraries
Obsoletes: libc-profile
Autoreq: true

%description profile
The glibc-profile package includes the GNU libc libraries and support
for profiling using the gprof program.  Profiling is analyzing a
program's functions to see how much CPU time they use and determining
which functions are calling other functions during execution.  To use
gprof to profile a program, your program needs to use the GNU libc
libraries included in glibc-profile (instead of the standard GNU libc
libraries included in the glibc package).

If you are going to use the gprof program to profile a program, you'll
need to install the glibc-profile program.

%package -n nscd
Summary: A Name Service Caching Daemon (nscd).
Group: System Environment/Daemons
Conflicts: kernel < 2.2.0
Prereq: /sbin/chkconfig
Autoreq: true

%description -n nscd
Nscd caches name service lookups and can dramatically improve
performance with NIS+, and may help with DNS as well. Note that you
can't use nscd with 2.0 kernels because of bugs in the kernel-side
thread support. Unfortunately, nscd happens to hit these bugs
particularly hard.

Install nscd if you need a name service lookup caching daemon, and
you're not using a version 2.0 kernel.

%prep
%setup -n glibc-2.1 -q -a 1 -a 2
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p0
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p0
 
%ifarch armv4l
rm -rf glibc-compat
%endif

find . -type f -size 0 -exec rm -f {} \;

%build
rm -rf build-$RPM_ARCH-linux
mkdir build-$RPM_ARCH-linux ; cd build-$RPM_ARCH-linux
%ifarch i586 i686
BuildFlags="-mpentium -D__USE_STRING_INLINES -fstrict-aliasing -mtune=%{_target_cpu}"
%endif
%ifarch sparcv9
BuildFlags="-mv8 -mtune=ultrasparc"
%endif
CC=egcs CFLAGS="$BuildFlags -g -O3" ../configure --prefix=/usr \
	--enable-add-ons=yes --without-cvs  \
	%{_target_cpu}-redhat-linux
make -r CFLAGS="$BuildFlags -g -O3" PARALLELMFLAGS=-s

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
make install_root=$RPM_BUILD_ROOT install -C build-$RPM_ARCH-linux
cd build-$RPM_ARCH-linux && \
    make install_root=$RPM_BUILD_ROOT install-locales -C ../localedata objdir=`pwd` && \
    cd ..

# compatibility hack: this locale has vanished from glibc, but some other
# programs are still using it. Normally we would handle it in the %pre
# section but with glibc that is simply not an option
mkdir -p $RPM_BUILD_ROOT/usr/share/locale/ru_RU/LC_MESSAGES

# Remove the files we don't want to distribute
rm -f $RPM_BUILD_ROOT/usr/lib/libNoVersion*

# the man pages for the linuxthreads require special attention
make -C linuxthreads/man
mkdir -p $RPM_BUILD_ROOT/usr/man/man3
install -m 0644 linuxthreads/man/*.3thr $RPM_BUILD_ROOT/usr/man/man3

gzip -9nvf $RPM_BUILD_ROOT/usr/info/libc*

ln -sf libbsd-compat.a $RPM_BUILD_ROOT/usr/lib/libbsd.a

install -m 644 $RPM_SOURCE_DIR/glibc-2.1-nsswitch.conf \
	$RPM_BUILD_ROOT/etc/nsswitch.conf

# Take care of setuids
# -- new security review sez that this shouldn't be needed anymore
#chmod 755 $RPM_BUILD_ROOT/usr/libexec/pt_chown

# This is for ncsd - in glibc 2.1
install -m 644 nscd/nscd.conf $RPM_BUILD_ROOT/etc
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
install -m 755 nscd/nscd.init $RPM_BUILD_ROOT/etc/rc.d/init.d/nscd

# The database support
mkdir -p $RPM_BUILD_ROOT/var/db
install -m 644 nss/db-Makefile $RPM_BUILD_ROOT/var/db/Makefile

# Strip binaries
strip $RPM_BUILD_ROOT/sbin/* || :
strip $RPM_BUILD_ROOT/usr/bin/* || :
strip $RPM_BUILD_ROOT/usr/sbin/* || :

# BUILD THE FILE LIST
find $RPM_BUILD_ROOT -type f -or -type l | 
	sed -e 's|.*/etc|%config &|' > rpm.filelist.in
for n in /usr/share /usr/include; do 
    find ${RPM_BUILD_ROOT}${n} -type d | \
	grep -v '^/usr/share$' | \
	sed "s/^/%dir /" >> rpm.filelist.in
done

# primary filelist
sed "s|$RPM_BUILD_ROOT||" < rpm.filelist.in | 
	grep -v '/etc/localtime'  | \
	grep -v '/etc/nsswitch.conf'  | \
	sort > rpm.filelist

grep '/usr/lib/lib.*_p\.a' < rpm.filelist > profile.filelist
egrep "(/usr/include)|(/usr/info)" < rpm.filelist | 
	grep -v /usr/info/dir > devel.filelist

mv rpm.filelist rpm.filelist.full
grep -v '/usr/lib/lib.*_p.a' rpm.filelist.full | 
	egrep -v "(/usr/include)|(/usr/info)" > rpm.filelist

grep '/usr/lib/lib.*\.a' < rpm.filelist >> devel.filelist
grep '/usr/lib/.*\.o' < rpm.filelist >> devel.filelist
grep '/usr/lib/lib.*\.so' < rpm.filelist >> devel.filelist
grep '/usr/man/man' < rpm.filelist >> devel.filelist

mv rpm.filelist rpm.filelist.full
grep -v '/usr/lib/lib.*\.a' < rpm.filelist.full |
	grep -v '/usr/lib/.*\.o' |
	grep -v '/usr/lib/lib.*\.so'|
	grep -v '/usr/man/man' | 
	grep -v 'nscd' > rpm.filelist

# /etc/localtime - we're proud of our timezone
rm -f $RPM_BUILD_ROOT/etc/localtime
cp -f $RPM_BUILD_ROOT/usr/share/zoneinfo/US/Eastern $RPM_BUILD_ROOT/etc/localtime
#ln -sf ../usr/share/zoneinfo/US/Eastern $RPM_BUILD_ROOT/etc/localtime

# the last bit: more documentation
rm -rf documentation
mkdir documentation
cp linuxthreads/ChangeLog  documentation/ChangeLog.threads
cp linuxthreads/Changes documentation/Changes.threads
cp linuxthreads/README documentation/README.threads
cp linuxthreads/FAQ.html documentation/FAQ-threads.html
cp -r linuxthreads/Examples documentation/examples.threads
cp crypt/README documentation/README.crypt
cp db2/README documentation/README.db2
cp db2/mutex/README documentation/README.db2.mutex
cp timezone/README documentation/README.timezone
cp ChangeLog* documentation
gzip -9 documentation/ChangeLog*

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%post devel
/sbin/install-info /usr/info/libc.info.gz /usr/info/dir

%pre devel
# this used to be a link and it is causing nightmares now
if [ -L /usr/include/scsi ] ; then
    rm -f /usr/include/scsi
fi

%preun devel
if [ "$1" = 0 ]; then
    /sbin/install-info --delete /usr/info/libc.info.gz /usr/info/dir
fi

%post -n nscd
/sbin/chkconfig --add nscd

%preun -n nscd
if [ $1 = 0 ] ; then
    /sbin/chkconfig --del nscd
fi

%clean
rm -rf "$RPM_BUILD_ROOT"
rm -f *.filelist*

%files -f rpm.filelist
%defattr(-,root,root)
%config(noreplace) /etc/localtime
%config(noreplace) /etc/nsswitch.conf
%doc README NEWS INSTALL FAQ BUGS NOTES PROJECTS
%doc documentation/* README.template README.libm
%doc login/README.utmpd hesiod/README.hesiod
%dir /var/db

%ifnarch sparcv9 i586 i686
%files -f devel.filelist devel
%defattr(-,root,root)

%files -f profile.filelist profile
%defattr(-,root,root)

%files -n nscd
%defattr(-,root,root)
%config /etc/nscd.conf
/etc/rc.d/init.d/nscd
/usr/sbin/nscd
%endif

%changelog
* Mon Nov 22 1999 Bill Nottingham <notting@redhat.com>
- add patch for malloc (jes)

* Wed Nov 10 1999 Bill Nottingham <notting@redhat.com>
- patch for bcopy on sparc (jakub)

* Thu Oct 14 1999 Cristian Gafton <gafton@redhat.com>
- add patch from DaveMfor sigaction header on sparc

* Mon Oct 11 1999 Cristian Gafton <gafton@redhat.com>
- new CVS snapshot

* Tue Sep 28 1999 Cristian Gafton <gafton@redhat.com>
- add sparcldso patch from DaveM to fix "a problem with statically linked
  binaries when dl-open'ing shared libraries on UltraSparc"
- update snapshot
- alpha siginfo patch

* Mon Sep 20 1999 Cristian Gafton <gafton@redhat.com>
- make /etc/localtime a real file instead of a symlink
- update snapshot, of course

* Thu Sep 16 1999 Cristian Gafton <gafton@redhat.com>
- update to the first 2.1.3 snapshot, but patch the version number back.
- disable some extra debugging messages form alpha/ioperm.c

* Tue Sep 07 1999 Cristian Gafton <gafton@redhat.com>
- update snapshot
- add sys/raw.h as anew header file

* Mon Sep 06 1999 Jakub Jelinek <jj@ultra.linux.cz>
- Build sparcv9 package instead of sparc64
- Don't build devel, profile and nscd subpackages for sparcv9

* Fri Sep 03 1999 Cristian Gafton <gafton@redhat.com>
- add the vfork patch for linuxthreads

* Fri Sep 03 1999 David S. Miller <davem@redhat.com>
- Build sparcv9 UltraSparc optimized 32-bit glibc
- Add glibc-2.1-sparcll.patch to fix UDIV_TIME redefinition.

* Wed Aug 25 1999 Cristian Gafton <gafton@redhat.com>
- another snapshot update
- fix for /usr/lib/pt_chown security problem included now

* Mon Aug 16 1999 Cristian Gafton <gafton@redhat.com>
- update snapshot
- fix #4437, #4389, #4535

* Mon Aug 02 1999 Cristian Gafton <gafton@redhat.com>
- upgraded snapshot to get the ld.so fixes for thread safety
- updated nsswitch.conf and made it %config(noreplace)

* Mon Jul 26 1999 Cristian Gafton <gafton@redhat.com>
- add sparc patch from jakub
- backported fclose patch from main devel tree

* Mon Jul 12 1999 Cristian Gafton <gafton@redhat.com>
- update for 2.1.2, the stable release of 2.1
- remove the patch that switched vfork with fork in libio/iopoen, as this
  should be handled now by a different patch
- statvfs patch no loger needed
- upgraded glibc-compat to 2.1.2 to address the __setfpucw problem (#3468)
- /etc/localtime is not a sylink anymore (#3816)
- add patch to implement xdr_ypall (#249)
- patch to link db_dump185 against the right db library (libdb1) (#2972)
- patch to fix the libpthread compatibility problem (#3738)
- patch to fix threads on SMP (#3693)
- patch to fix nscd alignment problem on the sparc (#3171)
- fix the bits/string.h header to stop generating compiler warnings.

* Mon Apr 26 1999 Cristian Gafton <gafton@redhat.com>
- alpha patches from Jay Estabrook to support the RX164

* Wed Apr 14 1999 Cristian Gafton <gafton@redhat.com>
- new CVS update - some patches dropped out
- updated obsoletes tag lines
- patch for the ukraine support

* Fri Apr 09 1999 Cristian Gafton <gafton@redhat.com>
- add patch for libstdc++ 2.7.2 (enable __dup, __pipe and __waitpid)
- linuxthread patch from HJLu
- add patch to make nscd respond to SIGHUP by dumping the cache

* Wed Apr 07 1999 Cristian Gafton <gafton@redhat.com>
- updated from cvs tree
- add patch for fstatvfs from HJLu

* Thu Apr 01 1999 Cristian Gafton <gafton@redhat.com>
- opentty fix
- don't call lddlibc4 on sparcs

* Thu Mar 25 1999 Cristian Gafton <gafton@redhat.com>
- version 2.1.1
- make nscd run by default at init
- nscd subpackage
- let the subpackages autoreq their own thing

* Fri Mar 12 1999 Cristian Gafton <gafton@redhat.com>
- version 2.1
- strip binaries installed by default

* Thu Feb 18 1999 Cristian Gafton <gafton@redhat.com>
- updated snapshot
- glibc-crypt might have export problems (who knows?), so we are nosource
  iit for now

* Wed Feb 03 1999 Cristian Gafton <gafton@redhat.com>
- version 2.0.112
- merge glibc-debug into glibc-devel
- new compat add-on

* Wed Jan 13 1999 Cristian Gafton <gafton@redhat.com>
- new glibc-crypt add-on
- version 2.0.109
- handle /etc/localtime separately
- don't include /usr/share in the file list
- don not build glibc-compat on the arm

* Wed Dec 02 1998 Cristian Gafton <gafton@redhat.com>
- build ver 2.0.105 on all four arches
- enabled /usr/include/scsi as part of the glibc package

* Fri Oct 02 1998 Cristian Gafton <gafton@redhat.com>
- first build for 2.0.96
